/*REXX*/
call rxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs
call rxFuncAdd 'RxAsyncLoadFuncs','RXASYNC','RxAsyncLoadFuncs'
call RxAsyncLoadFuncs

/* () 2:5021/22.21@fidonet */
/* ।祭  ᪠ - 뫠 */
/* । 奭 ,  , ᪮ 窨,  -䠩 */
ARG PortHandle PortNo LockSpeed LogName 

If LogName='' Then LogName='pppcalls.log' /*᫨   㪠*/

PortName='com'PortNo /*   ppp.exe  ப*/

Time=Time()
Date=Date()

Ethernet='00:80:48:EC:E1:90' /* 襩 ⥢*/
LocalIP='192.168.1.1' /*   ⪥ */

Cr=D2C(13)
Lf=D2C(10)
CrLf=Cr''Lf
UnsentCnt=0
LineCnt=0
Env='OS2ENVIRONMENT'
EtcDir=Value('ETC',,Env)
HostName=Translate(Value('HOSTNAME',,Env))
UsersFile=EtcDir'\pppusers.dat' /* ᪠ 䠩 */
EntryValid=0
ExtInfo=''

TotalCount=3 /* ᥣ ᪮쪮 ࠧ    -஫*/

LoginPrompt='Login: ' /*ਣ襭  */
Login=''
LoginLen=0
LoginCount=3 /*⮪  */
LoginTimeOut=10000 /*६    ᥪ㭤*/

PasswPrompt='Password: ' /*ਣ襭  ஫*/
Password=''
PasswLen=0
PasswCount=3 /*⮪  ஫*/
PasswTimeOut=10000 /*६   ஫ ᥪ㭤*/

/* , ᫨   ஫  ᮢ-ᮢ*/
strEntryInvalid='Login or Password is not found in user database'CrLf'and cannot be accepted as valid.'CrLf'Try again.'CrLf
strEntryValid='Your account info is found in user database, and accepted as incoming 'CrLf

/*  , ᫨   ࠧ  諨*/
OverCount='Attempts limit reached.'CrLf'Try again later.'CrLf'Bye.'CrLf

/* ⠭⭮ ਣ襭*/
SelfName="Hello. You have touched "HostName"'s PPP entry."CrLf''CrLf
SelfPrompt='You have 10 seconds to enter your login and'CrLf'the same time to enter your password. Good Luck'CrLf
SelfNote='Note, that login and password will be NOT VISIBLE!'CrLf'Please take attention, if you are typing in login and password manually'CrLf

/*砫  */
rc=Lineout(LogName)
rc=Lineout(LogName,'----------------------------------------------------')
rc=Lineout(LogName,'! Time: 'Time()'     Date: 'Date())
rc=Lineout(LogName,'! Port: 'PortName' handle: 'PortHandle' locked at: 'lockspeed)

/********************** 砫 ।⠢ *********************/
rc=RxAsyncWrite(PortHandle, 0, SelfName,'UnsentCnt')
rc=RxAsyncWrite(PortHandle, 0, SelfPrompt,'UnsentCnt')
rc=RxAsyncWrite(PortHandle, 0, SelfNote,'UnsentCnt')
rc=Lineout(LogName,'> Usual info sent.')
rc=RxAsyncWrite(PortHandle, 0, Crlf,'UnsentCnt')


CountLoop:
If TotalCount <= 0 then Signal EndJob
/*************   *************************/
GetLogin:
Time=Time('R')
rc=RxAsyncFlushInput(PortHandle)
/* ⢮ ⮪     ⠩ */
Do While LoginCount > 0
    rc=RxAsyncWrite(PortHandle, 0, Crlf,'UnsentCnt')
    rc=RxAsyncWrite(PortHandle, 0, LoginPrompt,'UnsentCnt') 
    rc=Lineout(LogName,'> 'LoginPrompt)
    rc=RxAsyncRead(PortHandle, 0, LoginTimeOut, 'Login','?',Cr)
    if rc = -1 then LoginCount=LoginCount - 1 
    if rc =  0 then Leave
End
/* ᫨ 襫    ,    */
If LoginCount = 0  then 
    Do
	rc=RxAsyncWrite(PortHandle, 0, OverCount,'UnsentCnt')  
        rc=Lineout(LogName,'! 'OverCount)
        rc=Lineout(LogName,'! Port Closed At:' Time())
	Signal EndJob
    End
/* ᫨   ࠢ쭮 ....*/
rc=RxAsyncWrite(PortHandle, 0, CrLf,'UnsentCnt') 
Login=Substr(Login,1,Length(Login)-1)
rc=Lineout(LogName,'< 'Login)
Time=Strip(Time('E'),,0)
rc=Lineout(LogName,'! Login Time Elapsed: 'Time' Sec.')
If Login = '' then 
     Do
         LoginCount=LoginCount - 1 
         Signal GetLogin
     End
/*****************  ஫ *************************/
GetPassw:
Time=Time('R')
rc=RxAsyncFlushInput(PortHandle)
/* ⢮ ⮪  ஫  ⠩*/
Do While PasswCount > 0
    rc=RxAsyncWrite(PortHandle, 0, Crlf,'UnsentCnt')
    rc=RxAsyncWrite(PortHandle, 0, PasswPrompt,'UnsentCnt')
    rc=Lineout(LogName,'> 'PasswPrompt)
    rc=RxAsyncRead(PortHandle, 0, PasswTimeOut, 'Password','?',Cr)
    if rc = -1 then PasswCount=PasswCount - 1
    If rc =  0 then Leave
End
/* ᫨ 諮 ⢮ ⮪  ஫ */
If PasswCount = 0  then 
    Do
	rc=RxAsyncWrite(PortHandle, 0, OverCount,'UnsentCnt')  
        rc=Lineout(LogName,'! 'OverCount)
        rc=Lineout(LogName,'! Port Closed At: 'Time())
	Signal EndJob
    End
/* ᫨  ࠢ쭮 ஫ */
rc=RxAsyncWrite(PortHandle, 0, CrLf,'UnsentCnt') 
Password=Substr(Password,1,Length(Password) - 1)
rc=Lineout(LogName,'< 'Password)
Time=Strip(Time('E'),,0)
rc=Lineout(LogName,'! Password Time Elapsed: 'Time' Sec.')
rc=Lineout(LogName)
If Password = '' then 
     Do
         PasswCount=PasswCount - 1 
         Signal GetPassw
     End
/*  ୮, ஫   -  ப */

Login=Translate(Login)
Password=Translate(Password)

/*   䠩  , ஫ﬨ,  ᠬ, ⠩⮬  ਥ*/
/*  ஢ઠ   /஫ */
Do i = 1 By 1 While Lines(UsersFile)
      currLine=LineIn(UsersFile)
      if Substr(CurrLine,1,1) = ';' then Iterate /* ਩ ; 諨, த...*/
      Parse UPPER VAR currLine dbLogin dbPassw dbIP dbTimeout dbComment 
      If (Length(dbLogin) \= Length(Login))|(Length(dbPassw)  \= Length(Password)) then Iterate
      If (Compare(dbLogin,Login) \=0) | (Compare(dbPassw,Password) \=0) then Iterate
      EntryValid=1
      Leave
End 

if EntryValid=0 Then 
   Do 
	rc=RxAsyncWrite(PortHandle, 0, strEntryInvalid,'UnsentCnt') 
	rc=Lineout(LogName,'! Attempt # '4-TotalCount' > Entry is invalid')
      	TotalCount=TotalCount-1
        Signal CountLoop 
   End

rc=RxAsyncWrite(PortHandle, 0,strEntryValid,'UnsentCnt') 
rc=Lineout(LogName,'! Entered: attempt # '4-TotalCount' > Entry is Valid')
ExtInfo='IP: 'DbIp' Timeout: 'dbTimeout' Comment: 'dbComment''CrLf
rc=Lineout(LogName,'! Entry info: 'ExtInfo)
rc=RxAsyncWrite(PortHandle, 0, ExtInfo,'UnsentCnt') 

/*  맮 ppp */
Rc=RxAsyncWrite(PortHandle, 0, 'Loading PPP'CrLf,'UnsentCnt') 
/* ਧ ⢨ ppp ᮥ */
'start haveppp.cmd'
/*  ⠡ ࠢ */
'arp -s 'dbIP' 'Ethernet' pub'
/* ⮢ 稬 */
'ipgate on'
/*  ⨬ */
'start "PPP timeout" /b /min /c killppp.cmd 'dbTimeout
/* 祬 ६ */
Time=Time('R')
/* */
'ppp.exe 'PortName' 'LockSpeed' 'LocalIP':'dbIp' defaultroute rtscts modem priority 1 idle 15 exit'
/* , ᪮쪮 ६ 뫨  ppp*/
Time=Strip(Time('E'),,0)
/*몫稬 ⮢*/
'ipgate off'
/*६   짮⥫ */
'arp -f'
/* ਧ  ppp*/
'start haveppp.cmd'

/*砭 ࠡ*/
EndJob:
rc=RxAsyncClose(PortHandle)
rc=Lineout(LogName,'! Session time : 'Time/60' Minutes')
exit
